package uk.ac.shef.is.imageClef.clusterAssessment;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;


/** Class is a container for a whole cluster assessment result file
 * @author Thomas Arni
 *
 */
public class ClusterAssessmentsContainer {	
	//<topic,ClusterTopicAssessmentsContainer>
	private HashMap<String, ClusterTopicAssessmentsContainer> topicClusterAssessments = new HashMap<String, ClusterTopicAssessmentsContainer>();
	
	public void add(ClusterAssessmentLineContainer cac){
		String topicNr = cac.getTopicNr();
		if(topicNr != null){
			if(topicClusterAssessments.containsKey(topicNr)){
				ClusterTopicAssessmentsContainer ctac = topicClusterAssessments.get(topicNr);
				ctac.add(cac);				
			}
			else{
				ClusterTopicAssessmentsContainer ctac = new ClusterTopicAssessmentsContainer(topicNr);
				ctac.add(cac);
				topicClusterAssessments.put(topicNr, ctac);
			}			
		}
		else System.err.println("Error during adding ClusterAssessmentContainer");
	}
	
	public boolean isAssessed(String topicNr, String docNo){
		boolean isAssessed = false;
		if(topicClusterAssessments.containsKey(topicNr)){
			ClusterTopicAssessmentsContainer ctac = topicClusterAssessments.get(topicNr);
			ArrayList<ClusterAssessmentLineContainer> al = ctac.getAssessments();
//			System.out.println("Size of ClusterAssessmentContainer = " +al.size());
			for(int i = 0;i<al.size();i++){
				ClusterAssessmentLineContainer cac = al.get(i);
//				int clusterId = Integer.parseInt(cac.getClusterId());
				String docNr = cac.getDocNr();
				if(docNr.equals(docNo)) return true;
			}	
		}
		return isAssessed;
	}
	
	public void print(){
		Iterator<Map.Entry<String, ClusterTopicAssessmentsContainer>> it = topicClusterAssessments.entrySet().iterator();
		while(it.hasNext()){
			Map.Entry<String, ClusterTopicAssessmentsContainer> entry = (Map.Entry<String, ClusterTopicAssessmentsContainer>)it.next();
			String topicNr = entry.getKey().toString();
			ClusterTopicAssessmentsContainer ctac = entry.getValue();
			ArrayList<ClusterAssessmentLineContainer> al = ctac.getAssessments();
			System.out.println(al.size());
			for(int i = 0;i<al.size();i++){
				ClusterAssessmentLineContainer cac = al.get(i);
				System.out.println("-->" + topicNr + "-" +cac.getTopicNr() + " " + cac.getClusterId() + " " + cac.getDocNr());
			}		
		}
	}

	public HashMap<String, ClusterTopicAssessmentsContainer> getTopicClusterAssessments() {
		return topicClusterAssessments;
	}
}
