package uk.ac.shef.is.imageClef.trecResult;

import java.util.HashMap;

/** Class is a container for the max. 1000
 * results in the usual trec result file 
 * structure.
 * An instance of a TrecResult stores the
 * result from 1 topic.
 * @author Thomas Arni
 *
 */
public class TrecTopicResultsContainer {
	private String topicNr = "";
	private String filePath = null;
	
	// Hash<rank, TrecResultEntry>
	private HashMap<String, TrecResultEntryContainer> topicResults = new HashMap<String, TrecResultEntryContainer>();
	
	public TrecTopicResultsContainer(String topicNr){
		this.topicNr = topicNr;
	}
	
	public void addTrecResultEntry(TrecResultEntryContainer tre){
		topicResults.put(tre.getRank(), tre);
	}
	
	public HashMap<String, TrecResultEntryContainer> getTopicResults(){
		return topicResults;
	}
	
	public String getDocByRank(String rank){
		if(topicResults.get(rank) != null){
			return topicResults.get(rank).getDocNr();
		}
		else return null;
	}

	public String getTopicNr() {
		return topicNr;
	}
	
	public int getNumberOfResults(){
		return topicResults.size();
	}
	
	public String getFilePath() {
		return filePath;
	}

	public void setFilePath(String filePath) {
		this.filePath = filePath;
	}
}
